;sample program: data memory fill and move
;author: (c) Benesoczky Zoltan
.device ATmega328P


;constant definitions
.equ RAM_START = 0x100 		;RAM start address of ATmega128
.equ constant1 = 0xaa		;definition of constatnt

;rename of the registers
.def byte_count = R16		
.def tmp = R17


;data segment (RAM)
		.DSEG		
		.ORG		RAM_START

.equ data_num = 16
mem1: 	.BYTE data_num	;memory space allocation
mem2:	.BYTE data_num

;code segment (FLASH)
		.CSEG		
		jmp	start

MAIN:
start:	ldi		tmp,low(RAMEND)
		out		SPL,tmp
		ldi		tmp, high(RAMEND)
		out 	SPH,tmp
loop_MAIN:
		
;fill memory
		ldi		XL,low(mem1)
		ldi		XH,high(mem1)
		LDI		byte_count,data_num
		CLR		tmp
cycle1: ST		X+,tmp
		INC		tmp
	    DEC		byte_count
	    BRNE	cycle1


;fill memory
		ldi		XL,low(mem2)
		ldi		XH,high(mem2)
		LDI		byte_count,data_num
		SER		tmp
cycle2: ST		X+,tmp
	    DEC		byte_count
	    BRNE	cycle2


;move memory
		LDI		XL, low(mem1)
	    LDI		XH, high(mem1) 		;X=forras_cim
	    LDI		YL, low(mem2)
	    LDI		YH, high(mem2)	 	;Y=cel_cim
	    LDI		byte_count, data_num
cycle3: LD 		tmp,X+
	    ST		Y+,tmp
	    DEC		byte_count
	    BRNE	cycle3

		jmp		loop_MAIN


