// AVR ADC handler


#define Trg_FreeRun 0x00
#define Trg_AComp 0x01
#define Trg_IRQ0 0x02
#define Trg_OC0 0x03
#define Trg_OV0 0x04
#define Trg_OC1 0x05
#define Trg_OV1 0x06
#define Trg_IC1 0x07

#define Ref_ext 0x00
#define Ref_AVCC 0x40
#define Ref_1V1 0xc0
 
extern void ADC_Init(unsigned char Ref, unsigned char ch, unsigned char trigg, unsigned char fdiv, unsigned int sw_div);
//extern void AD_ITDIS(void);
//extern void AD_ITEN(void);
//extern void ADC_BuffReset();

#define ADC0 0x00
#define ADC1 0x01
#define ADC2 0x02
#define ADC3 0x03
#define ADC4 0x04
#define ADC5 0x05
#define ADC6 0x06
#define ADC7 0x07
#define ADC_Temp 0x08
#define ADC_1V1 0x0e
#define ADC_GND 0x0f
extern void AD_ChannelSet(unsigned char ch);

// A normal conversion takes 13 ADC clock cycles
// fsamp = FCPU/(fdiv*13)
// 50kHz-200kHz
#define fdiv_2		1
#define fdiv_4		2
#define fdiv_8		3
#define fdiv_16		4
#define fdiv_32		5
#define fdiv_64		6
#define fdiv_128	7

extern void AD_FrequSet(unsigned char fdiv);

extern unsigned char Get_ADC(unsigned int *ADvar);
extern unsigned char Get_ADC_Voltage(double *ADvoltage,double ADref);

