//LCD functions:

#ifndef LCD_hlr
#define LCD_hlr
#endif

#define line1 1
#define line2 2
#define left 0
#define right 1
//functions to use
extern void Delaysw(long t);
extern void LCD_init(void);							// Initialisation must call after enabled IT
extern void LCD_write_str(char * s, unsigned char line);		//write string to lcd
extern void LCD_write_str_pos(char * s, unsigned char line, unsigned char pos);	//write string to lcd pos
extern void LCD_write_int_pos(int int_var, unsigned char line, unsigned char pos);	// write int to LCD
extern void LCD_write_double_pos(double double_var, char with, unsigned char prec, unsigned char line, unsigned char pos);	// write double to LCD
extern void LCD_write_str_int(char * s, int data, unsigned char side, unsigned char line);	//write string and integer
extern void LCD_write_longstr(char * s);
extern void LCD_light(unsigned char bright);		// set LCD backlight (bright: 0-15)

// not to call!!
extern void LCD_wr_from_IT(void);	// incuded to Timer0extension()
// volatile variables of LCD_wr_from_IT

/*
extern volatile int LCD_WR_RDY;
extern volatile int StrIndex;
extern volatile char * StrPtr;
extern volatile char ITstr [20];
extern volatile char LCDline;
*/