// UART handler */

//#define UBRR_VALUE  (unsigned int)((CLK/(16*BAUD)-1) & 0x0fff)
// CLK: MHz

#define CR 0x0d

typedef struct UART_Type
{
	unsigned char value;
	unsigned char is_data;
} UART_Type;

extern void USART0_Init(unsigned int baud_set_value);

// receive datas
extern unsigned char S_DAT;        //SIO bejovo adat (GET_SIO()-tol)
extern unsigned char GET_UART(unsigned char * UARTvar);

// transmit datas
extern volatile unsigned char TR_END;                  /* serial output finished */
extern unsigned char *serobuf;
extern char  serou_leng;
extern void TRANSMIT_START(unsigned char *buf, char length);
extern void WAIT_TREND(void);

extern void sout_hexbyte(unsigned char wdat);
extern void sout_hexword(unsigned int wdat);
extern void sout_byte(unsigned char bdat);
extern void SerouString(const char *input_str);
extern void CrLf(void);
