//Keyboard scan
#include <avr/io.h>
#include <inttypes.h>
#include "BooleConst.h"
#include "Keyboard_def.h"
#include "Keyboard_hlr.h"

static volatile uint8_t key_new;
static volatile uint8_t key_old;
static volatile KeyType KeyResult;
static volatile int Key_timcnt;

#define InitKeyScan Key_timcnt = KeyScanTime

void KScan(void)
{
	if(!KeyResult.pressed)
	{
		key_new = ~KeyPIN & KeyMask;
		KeyResult.value = key_new & ~key_old;
		key_old = key_new;
		if(KeyResult.value)
		{
			KeyResult.pressed = TRUE;
		}
	}
}

void KeyScan(void)
{
	if(Key_timcnt > 0) Key_timcnt--;
	else
	{
		InitKeyScan;
		KScan();
	}
}


void KeyInit(void)
{
	InitKeyScan;
	KeyResult.pressed = FALSE;
	KScan();
}


void KeyPressed(KeyType *result)
{
	if(KeyResult.pressed)
	{
		(*result).value = KeyResult.value;	//copy value
		(*result).pressed = TRUE;
		KeyResult.pressed = FALSE;	//send to IT
	}
	else
	{
		(*result).pressed = FALSE;
	}
}
